--WHEN ADDING:
	--GEAR TOKEN - Add the tier to the tierTypes list, add the new tokens in the "TOKENS" section and the Locale-enUS file
	--(Other)    - Add the other things to the list they belong to

local mod = UpgradeList:NewModule("ItemLocations")
local L = LibStub("AceLocale-3.0"):GetLocale("UpgradeList")

local UPGRADELIST_VERSION = GetAddOnMetadata('UpgradeList', 'Version')
local _, englishClass = UnitClass("player")

function UpgradeList:LoadDropdownItems()

	--Strings------------------------------------------------------------------------------------------
		
	local raidTypes = {
		[1] = _G["PLAYER_DIFFICULTY2"], --Heroic
		[2] = _G["PLAYER_DIFFICULTY1"], --Normal
		[3] = _G["PLAYER_DIFFICULTY3"], --LFR
	}
	
	local dungeonTypes = {
		[1] = _G["PLAYER_DIFFICULTY2"], --Heroic
		[2] = _G["PLAYER_DIFFICULTY1"], --Normal
	}
	
	local currency = {
		[1] = L["Gear Token"],
		[2] = "396", --Valor Points
		[3] = "395", --Justice Points
		[4] = "390", --Conquest Points
		[5] = "392", --Honor Points
	}
	
	for cur,number in pairs(currency) do
		if cur ~= 1 then
			currency[cur] = GetCurrencyInfo(number)
		end
	end

	local tierTypes = {
		[1] = L["Tier 14"],
	}

	local reputationLevels = {
		[1] = _G["FACTION_STANDING_LABEL8"], --Exalted
		[2] = _G["FACTION_STANDING_LABEL7"], --Revered
		[3] = _G["FACTION_STANDING_LABEL6"], --Honored
		[4] = _G["FACTION_STANDING_LABEL5"], --Friendly
	}
	
	local expansionLevels = {
		[1] = EJ_GetTierInfo(5), --MoP
		[2] = EJ_GetTierInfo(4), --Cata
		[3] = EJ_GetTierInfo(3), --WotLK
		[4] = EJ_GetTierInfo(2), --fix for dungeon journal calling the expansion "Burning Crusade" and the global string calling it "The Burning Crusade"
		[5] = EJ_GetTierInfo(1), --Classic
	}
		
	--Professions--------------------------------------------------------------------------------------
	local localizedProfessionNames = {
		[1] = "78670", --Archaeology
		[2] = "2259", --Alchemy
		[3] = "2018", --Blacksmithing
		[4] = "7411", --Enchanting
		[5] = "4036", --Engineering
		[6] = "45357", --Inscription
		[7] = "25229", --Jewelcrafting
		[8] = "2108", --Leatherworking
		[9] = "3908", --Tailoring
	}
	local professions = {}

	for prof,number in pairs(localizedProfessionNames) do
		professions[prof] = GetSpellInfo(number)
	end

	--Reputations--------------------------------------------------------------------------------------
	local numMoPReps = GetAchievementNumCriteria(6827)
	local reputations = {}

	for i = 1, numMoPReps, 1 do
		reputations[i] = GetAchievementCriteriaInfo(6827, i)
	end

	--Tokens-------------------------------------------------------------------------------------------
	--Format: [##] = {"token_number", "token_name", instance, boss, difficulty
	local tokens = {}
	local function GI(instanceID) --GI: GetInstance
		local name = EJ_GetInstanceInfo(instanceID)
		return name
	end
	local function GB(instanceID, bossIndex) --GB:GetBoss
		EJ_SelectInstance(instanceID)
		local boss = EJ_GetEncounterInfoByIndex(bossIndex)
		return boss
	end
	
	--330 - Heart of Fear
	--320 - Terrace of Endless Spring
	

	if (englishClass == "DEATHKNIGHT") or (englishClass == "DRUID") or (englishClass == "MAGE") or (englishClass == "ROGUE") then --Vanquisher
		tokens = {
			--Tier 14
			--Heroic
			[1] = {"89258", "", GI(320), GB(320,4), L["Tier 14"], raidTypes[1]}, --Crown
			[2] = {"89261", "", GI(320), GB(320,3), L["Tier 14"], raidTypes[1]}, --Shoulders
			[3] = {"89249", "", GI(330), GB(330,6), L["Tier 14"], raidTypes[1]}, --Chest
			[4] = {"89255", "", GI(330), GB(330,4), L["Tier 14"], raidTypes[1]}, --Gauntlets
			[5] = {"89252", "", GI(330), GB(330,5), L["Tier 14"], raidTypes[1]}, --Leggings
			
			--Normal
			[6] = {"89234", "", GI(320), GB(320,4), L["Tier 14"], raidTypes[2]}, --Crown
			[7] = {"89248", "", GI(320), GB(320,3), L["Tier 14"], raidTypes[2]}, --Shoulders
			[8] = {"89239", "", GI(330), GB(330,6), L["Tier 14"], raidTypes[2]}, --Chest
			[9] = {"89242", "", GI(330), GB(330,4), L["Tier 14"], raidTypes[2]}, --Gauntlets
			[10] = {"89245", "", GI(330), GB(330,5), L["Tier 14"], raidTypes[2]}, --Leggings
			
			--LFR
			[11] = {"89273", "", GI(320), GB(320,4), L["Tier 14"], raidTypes[3]}, --Crown
			[12] = {"89276", "", GI(320), GB(320,3), L["Tier 14"], raidTypes[3]}, --Shoulders
			[13] = {"89264", "", GI(330), GB(330,6), L["Tier 14"], raidTypes[3]}, --Chest
			[14] = {"89270", "", GI(330), GB(330,4), L["Tier 14"], raidTypes[3]}, --Gauntlets
			[15] = {"89267", "", GI(330), GB(330,5), L["Tier 14"], raidTypes[3]}, --Leggings
		}
	elseif (englishClass == "PALADIN") or (englishClass == "PRIEST") or (englishClass == "WARLOCK") then --Conqueror
		tokens = {
			--Tier 14
			--Heroic
			[1] = {"89259", "", GI(320), GB(320,4), L["Tier 14"], raidTypes[1]}, --Crown
			[2] = {"89262", "", GI(320), GB(320,3), L["Tier 14"], raidTypes[1]}, --Shoulders
			[3] = {"89250", "", GI(330), GB(330,6), L["Tier 14"], raidTypes[1]}, --Chest
			[4] = {"89256", "", GI(330), GB(330,4), L["Tier 14"], raidTypes[1]}, --Gauntlets
			[5] = {"89253", "", GI(330), GB(330,5), L["Tier 14"], raidTypes[1]}, --Leggings
			
			--Normal
			[6] = {"89235", "", GI(320), GB(320,4), L["Tier 14"], raidTypes[2]}, --Crown
			[7] = {"89249", "", GI(320), GB(320,3), L["Tier 14"], raidTypes[2]}, --Shoulders
			[8] = {"89240", "", GI(330), GB(330,6), L["Tier 14"], raidTypes[2]}, --Chest
			[9] = {"89243", "", GI(330), GB(330,4), L["Tier 14"], raidTypes[2]}, --Gauntlets
			[10] = {"89246", "", GI(330), GB(330,5), L["Tier 14"], raidTypes[2]}, --Leggings
			
			--LFR
			[11] = {"89274", "", GI(320), GB(320,4), L["Tier 14"], raidTypes[3]}, --Crown
			[12] = {"89277", "", GI(320), GB(320,3), L["Tier 14"], raidTypes[3]}, --Shoulders
			[13] = {"89265", "", GI(330), GB(330,6), L["Tier 14"], raidTypes[3]}, --Chest
			[14] = {"89271", "", GI(330), GB(330,4), L["Tier 14"], raidTypes[3]}, --Gauntlets
			[15] = {"89268", "", GI(330), GB(330,5), L["Tier 14"], raidTypes[3]}, --Leggings
		}
	elseif (englishClass == "HUNTER") or (englishClass == "SHAMAN") or (englishClass == "WARRIOR") or (englishClass == "MONK") then --Protector
		tokens = {
			--Tier 14
			--Heroic
			[1] = {"89260", "", GI(320), GB(320,4), L["Tier 14"], raidTypes[1]}, --Crown
			[2] = {"89263", "", GI(320), GB(320,3), L["Tier 14"], raidTypes[1]}, --Shoulders
			[3] = {"89251", "", GI(330), GB(330,6), L["Tier 14"], raidTypes[1]}, --Chest
			[4] = {"89257", "", GI(330), GB(330,4), L["Tier 14"], raidTypes[1]}, --Gauntlets
			[5] = {"89254", "", GI(330), GB(330,5), L["Tier 14"], raidTypes[1]}, --Leggings
			
			--Normal
			[6] = {"89236", "", GI(320), GB(320,4), L["Tier 14"], raidTypes[2]}, --Crown
			[7] = {"89250", "", GI(320), GB(320,3), L["Tier 14"], raidTypes[2]}, --Shoulders
			[8] = {"89241", "", GI(330), GB(330,6), L["Tier 14"], raidTypes[2]}, --Chest
			[9] = {"89244", "", GI(330), GB(330,4), L["Tier 14"], raidTypes[2]}, --Gauntlets
			[10] = {"89247", "", GI(330), GB(330,5), L["Tier 14"], raidTypes[2]}, --Leggings
			
			--LFR
			[11] = {"89275", "", GI(320), GB(320,4), L["Tier 14"], raidTypes[3]}, --Crown
			[12] = {"89278", "", GI(320), GB(320,3), L["Tier 14"], raidTypes[3]}, --Shoulders
			[13] = {"89266", "", GI(330), GB(330,6), L["Tier 14"], raidTypes[3]}, --Chest
			[14] = {"89272", "", GI(330), GB(330,4), L["Tier 14"], raidTypes[3]}, --Gauntlets
			[15] = {"89269", "", GI(330), GB(330,5), L["Tier 14"], raidTypes[3]}, --Leggings
		}
	end

	for i = 1, #tokens, 1 do
		tokens[i][2] = GetItemInfo(tokens[i][1])
	end

	function UpgradeList:LoadTierTokenNames()
		for i = 1, #tokens, 1 do
			tokens[i][2] = GetItemInfo(tokens[i][1])
		end
	end
	
	local generalItemLocations = {
		{_G["CHAT_MSG_RAID"], expansionLevels, raidTypes, self.db.Raids, self.db.Raids},
		{_G["ENCOUNTER_JOURNAL_INSTANCE"], expansionLevels, dungeonTypes, self.db.Dungeons, self.db.Dungeons},
		{_G["TRADE_SKILLS"], professions},
		{_G["QUESTS_LABEL"]},
		{_G["REPUTATION"], reputations, reputationLevels},
		{_G["PURCHASE"], currency, tierTypes, raidTypes, tokens},
		{_G["CHANNEL_CATEGORY_WORLD"]},
		{_G["OTHER"]},
	}
	
	self.db.Constants.GeneralItemLocations = generalItemLocations
	self.db.Constants.Professions = professions
	self.db.Constants.Reputations = reputations
	self.db.Constants.Currency = currency
	
end